cache:
  key: "$CI_BUILD_REF_NAME node:12-alpine"
  paths:
  - node_modules/

stages:
  - build
  - release
  - deploy

build:
  stage: build
  image: rastasheep/alpine-node-chromium:8-alpine
  variables:
    NODE_ENV: "development"
  before_script:
    - apk add --update bash
    - apk add --update git && rm -rf /tmp/* /var/cache/apk/* 
  script: 
    - npm install --silent 
  tags:
    - ekosistem-data-jabar


release:
  stage: release
  image: docker:latest
  only:
    - "master"
  services:
    - docker:dind
  variables:
    DOCKER_DRIVER: "overlay"
  before_script:
    - "docker version"
    - "docker info"
    - "docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY"
  script:
    - "docker build -t ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest --pull ."
    - "docker push ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest"
  after_script:
    - "docker logout ${CI_REGISTRY}"
  tags:
    - ekosistem-data-jabar


deploy:
  stage: deploy
  image: alpine:latest
  only:
    - "master"
  services:
    - docker:dind
  before_script:
    - apk add --update --no-cache openssh sshpass
  script:
    - printf "home/opendata/docker-script/${CI_PROJECT_PATH}/${CI_COMMIT_REF_NAME}/${CI_COMMIT_SHA}"
    - sshpass -p "${DEPLOYMENT_SERVER_PASS}" ssh -o StrictHostKeyChecking=no -o PreferredAuthentications=password -o PubkeyAuthentication=no $DEPLOYMENT_SERVER_USER@$DEPLOYMENT_SERVER_IP "mkdir -p /home/opendata/docker-script/${CI_PROJECT_PATH}/${CI_COMMIT_REF_NAME}"
    - sshpass -p "${DEPLOYMENT_SERVER_PASS}" scp -o StrictHostKeyChecking=no -o PreferredAuthentications=password -o PubkeyAuthentication=no ./docker-compose.yml ${DEPLOYMENT_SERVER_USER}@${DEPLOYMENT_SERVER_IP}:/home/opendata/docker-script/${CI_PROJECT_PATH}/${CI_COMMIT_REF_NAME}/
    - sshpass -p "${DEPLOYMENT_SERVER_PASS}" ssh -o StrictHostKeyChecking=no -o PreferredAuthentications=password -o PubkeyAuthentication=no $DEPLOYMENT_SERVER_USER@$DEPLOYMENT_SERVER_IP "sudo -S ls && docker login -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY}; sudo docker-compose -f /home/opendata/docker-script/${CI_PROJECT_PATH}/${CI_COMMIT_REF_NAME}/docker-compose.yml stop; sudo docker-compose -f /home/opendata/docker-script/${CI_PROJECT_PATH}/${CI_COMMIT_REF_NAME}/docker-compose-master.yml rm opendata-jdvf-landing-page; sudo docker pull ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest; sudo docker-compose -f /home/opendata/docker-script/${CI_PROJECT_PATH}/${CI_COMMIT_REF_NAME}/docker-compose.yml up -d"
  tags:
    - ekosistem-data-jabar
